#ifndef _define_analog_
#define _define_analog_
#include "data.h"

class neuron{

data *n_data;
table *n_outp,*n_err;

long **n_model,
     *n_priznak,
     *n_property,
     *n_lmodel,
     *n_rmodel,
     *n_work;


double *n_distance,
       *n_activity,
       *n_mean_val,
       *n_an_space;

      private:
long n_inputs,     // amount of the parameters
     n_active,    //  amount active outputs
     n_output,    // amount of outputs for all networks
     n_sample;    // amount of moleculs

	public:
//functions:
        neuron(data*,table*,table*,long *prop,long input);
	~neuron();
        void convergence(long nl,long nn); //optimization amount of parameters
        double complexation(long input,long nn); //integration by method of analogs
        void predict(long layer,long xi,long *analogs);// predict
        void reduse_sorting();// Optimization parameter amount
        void total_sorting();// Method analoga:optimization of parameter amount
        double complex_one(long type,long pr=0); //integration by method of one analogs
};


class analog{

data *an_data; // dataset used for network training
table *an_outp,*an_err;
static neuron *an_neuron;

long an_input,  //amount of neurons
     an_active, //amount of active outputs
     an_layer,  //maximal amount of layers
     an_hidden, //amount of neurons in layer
     an_output, //amount of output parameters
     an_sample; // amount of examples

long *an_property,
     *an_work,
     *an_analogs;

double an_error,an_berr;		// error and best error

	public:
//functions:
	analog(int *layers,dataset *d);
	~analog();
        void gl_calculation();
        void data_organize(); // copy input data in table
        void full_predict(long layer);
};
#endif

