#define insert_variables_here

//#include "stdafx.h"

#include <stdarg.h>
#include <math.h>
#include <stdlib.h> 
#include "defines.h"
#include "data.h"

// this file contains all function for bin, table, data, dataset


double range_funact(long function,long value)
{
switch(function)
{
	case c_exp: return p_normv==2?(value?1:0):value?0.9:0.1;
	case c_th:;
	case c_xx:;
	case c_line:return p_normv==2?(value?1.:-1.):value?0.9:-0.9;
	case c_sigm: return p_normv==2?(value?0.5:-0.5):value?0.4:-0.4;
	default: error("in range_funact for function=%i",function);
}
return 0.;
}

void print_param(FILE *f,long size,double *var)
{
double *v,*end;
for(v=var,end=v+size;v<end;v++)  fprintf(f,"%f\t",*v);
}


long param::input(char *str,char *str1)
{
int input_param;
if(strlen(str)==strlen(s)&&strstr(str,s)){
loaded=changed=1;
if(type==0){sscanf(str1,"%i",&input_param);*a=input_param;}
		else
		{sscanf(str1,"%f",&f);*b=f;}
	return 1;}
return 0;
}

void param::print(FILE *file,int &count,int mode)
{
if(mode==c_on||changed){
		if(type==1)fprintf(file,"%s=%5.4f%s",s,*b,count?" ":"\n");
				else
				fprintf(file,"%s=%i%s",s,int(*a),count?" ":"\n");
		count=count==4?0:count+1;}
}


void param::copy(param p)
{
// to create a "pooll" of initial parameters
 
if(type==-1){type=p.type; if(type==1){b=new double;*b=*p.b;}
								else
								{a=new long;*a=*p.a;}
			}

// if parameter was loaded - it should be indicated in all records!

loaded=p.loaded;

// to restore default value (except loaded)

if(changed&&!loaded){
		if(type==1)*b=*p.b;
				else
				*a=*p.a;}
changed=0;
}			

void copy_parameters(param p1[],param p2[])
{
for(long i=0;i<c_param_number;i++)p1[i].copy(p2[i]);
}

int compare_param(const void *a,const void *b)
{param *l=(param*)a,*r=(param*)b;
return strcmp(l->name(),r->name());
}

void compare_parameters(param p1[],param p2[])
{
for(long i=0;i<c_param_number;i++)p1[i].compare(p2[i]);
}

FILE *mfopen(char *s,char *param)
{
#ifdef unix_computer
char name[200];
sprintf(name,"%s%s",environment,s);
return fopen(name,param);
#else
return fopen(s,param);
#endif
}

	
long field_scanf(FILE *in)
{
static char *str=new char[c_array+1];
char *s,str1[1000];
unsigned long start=ftell(in);
long i=0;
str[0]=str1[0]=0;
fgets(str,c_array,in);
for(s=str;sscanf(s,"%s",str1)==1;i++)s=strstr(s,str1)+strlen(str1);
fseek(in,start,SEEK_SET);
return i;
}


int compare_l(const void *l,const void *r)
{
return (*((long*)r)-*((long*)l));
}

int compare_d(const void *l,const void *r)
{
double a=(*((double*)r)-*((double*)l));
return a>0.?-1:a<0.?1:0;
}

void error(char *fmt...)
{
va_list argptr;
va_start(argptr, fmt);
printf("\n\n\aError!!! ERror!!! ERRor!!! ERROr!!! ERROR!!! ERRrrRRrrOR!!!!!!!\n");
vprintf(fmt, argptr);
printf("\n");
va_end(argptr);
exit(1);
}

#define M1 259200
#define IA1 7141
#define IC1 54773
#define RM1 (1.0/M1)
#define M2 134456
#define IA2 8121
#define IC2 28411
#define RM2 (1.0/M2)
#define M3 243000
#define IA3 4561
#define IC3 51349

double ran1(long *idum)
{
	static long ix1,ix2,ix3;
	static double r[98];
	double temp;
	static long iff=0;
	long j;

	if (*idum < 0 || iff == 0) {
		iff=1;
		ix1=(IC1-(*idum)) % M1;
		ix1=(IA1*ix1+IC1) % M1;
		ix2=ix1 % M2;
		ix1=(IA1*ix1+IC1) % M1;
		ix3=ix1 % M3;
		for (j=1;j<=97;j++) {
			ix1=(IA1*ix1+IC1) % M1;
			ix2=(IA2*ix2+IC2) % M2;
			r[j]=(ix1+ix2*RM2)*RM1;
		}
		*idum=1;
	}
	ix1=(IA1*ix1+IC1) % M1;
	ix2=(IA2*ix2+IC2) % M2;
	ix3=(IA3*ix3+IC3) % M3;
	j=1 + ((97*ix3)/M3);
	if (j > 97 || j < 1) error("ran1: This cannot happen.");
	temp=r[j];
	r[j]=(ix1+ix2*RM2)*RM1;
	return temp;
}

#undef M1
#undef IA1
#undef IC1
#undef RM1
#undef M2
#undef IA2
#undef IC2
#undef RM2
#undef M3
#undef IA3
#undef IC3

// some statistical functions

double mean_value(double *elem,double *end,long step)
{
double mean=0;long n=0;
for(;elem<end;elem+=step)if(*elem<p_cut){mean+=*elem;n++;}
return n?mean/n:p_cut;
}


double correlation(double *elem1,double *elem2,double*end,long step,long group)
{
double *end1,x=0.,y=0.,yy=0.,xx=0.,xy=0.;
long n=0,delta=step-group;

TT if(delta<0)error("delta is %i < 0 in correlation",delta);

for(;elem1<end;elem1+=delta,elem2+=delta)
	for(end1=elem1+group;elem1<end1;elem1++,elem2++)if(*elem1<p_cut&&*elem2<p_cut)
		{
		x+=*elem1;y+=*elem2;
		xx+=(*elem1)*(*elem1);
		yy+=(*elem2)*(*elem2);
		xy+=(*elem1)*(*elem2);
		n++;
		}
xx=(n*xx-x*x)*(n*yy-y*y);

return n<2||xx<=0.?1:(n*xy-x*y)/sqrt(xx);

}

double covariance(double *elem1,double *elem2,double*end,long step1,long step2)
{
double x=0.,y=0.,xy=0.;
long n=0;

for(;elem1<end;elem1+=step1,elem2+=step2)
		{
		x+=*elem1;y+=*elem2;
		xy+=(*elem1)*(*elem2);
		n++;
		}
return n*xy-x*y;
}


double dispersion(double *elem, double *end,double meanv,long step)
{
double dispv=0.,dd; long n=0;
for(;elem<end;elem+=step)if((*elem)<p_cut)
		{dd=(*elem)-meanv;
		dispv+=dd*dd;
		n++;}

return n<2?0:sqrt(dispv/(n-1.));
}

long max_abs_val(long length, double *ar)
{
long i,n=0;double a,b;
a=*ar>0?*ar:-(*ar);ar++;
for(i=1;i<length;i++,ar++){b=*ar>0?*ar:-(*ar);if(b>a){n=i;a=b;}}
return n; 
}

long min_abs_val(long length, double *ar)
{
long i,n=0;double a,b;
a=*ar>0?*ar:-(*ar);ar++;
for(i=1;i<length;i++,ar++){b=*ar>0?*ar:-(*ar);if(b<a){n=i;a=b;}}
return n; 
}


double mse(double *x,double *y, long n)
{
double v=0.,vv,*end=x+n;
for(;x<end;x++,y++)if((*x)<p_cut&&(*y)<p_cut){vv=(*x)-(*y);v+=vv*vv;}
return v;
}

double calc_mse(double *x,double *y, long n)
{
double v=0.,vv,*end=x+n;
long count=0;
for(;x<end;x++,y++)if((*x)<p_cut&&(*y)<p_cut){vv=(*x)-(*y);v+=vv*vv;count++;}
return count?sqrt(v/count):0.;
}

bin::bin(int no,FILE *in)
{
int i,j,no1,len;
int long where;
char *s,str[100];
if(no<=1)error("error in bin mask length=%i<=1\nINCLUDE should follow LAYERS",no);
b_length=no;
b_size=(b_length%c_int_bit)?1:0;b_size+=b_length/c_int_bit;
b_array=new int[b_size];clear();

len=field_scanf(in);
if(len==1){
	where=ftell(in);
	fgets(str,99,in);
	if(strstr(str,"-")!=NULL)len=2;
	fseek(in,where,SEEK_SET);
	}

if(len>1)for(i=0,no1=-1;i<len;i++){
	fscanf(in,"%i",&no);
	if(no>0){no--;
			check_number(no,b_length);
			on(no);
			no1=no;
			if(i==len-1){
					where=ftell(in);
					fgets(str,99,in);
					if(strstr(str,"-")!=NULL)len++;
					fseek(in,where,SEEK_SET);
					}
			}
			else
			{
			if(no1<0)error("in bin::bin input");
			no=-no;
			check_number(no-1,b_length);
			for(j=no1;j<no;j++)on(j);
			i--;no1=-1;
			}
	}
	else
	{
	s=new char[c_array+1];
	fscanf(in,"%s",s);
	if(strlen(s)!=b_length)error("in MASK scanf operator. Length for binary scan=%i != b_length=%i\nMASK should follow LAYERS",len,b_length);
	for(i=0;i<b_length;i++,s++){sscanf(s,"%1i",&no);if(no)on(i);}	
	delete s;
	}
}

bin::bin(int s)
{
b_length=(s>0)?s:-s;
b_size=(b_length%c_int_bit)?1:0;b_size+=b_length/c_int_bit;
if(s>0){b_array=new int[b_size];
		clear();
		TT if(all_on())error("in bin::bin");
		}
	else
	b_array=NULL;
}

void bin::set_on(bin*mask)
{
int *begin=b_array,*value=mask->b_array,*end=b_array+b_size;
for(;begin<end;begin++,value++)(*begin)|=(*value); 
}

void bin::set_off(bin*mask)
{
int *begin=b_array,*value=mask->b_array,*end=b_array+b_size;
for(;begin<end;begin++,value++)(*begin)&=~(*value); 
}


void bin::invert()
{
int *begin=b_array,*end=b_array+b_size;
for(;begin<end;begin++)(*begin)=~(*begin); 
}
	
int bin::all_on(int number)
{
int *begin=b_array,*end,all=0,n,i;

TT if(number>b_length)error("In all_on number=%i>b_length=%i",number,b_length);
number=(number<0)?b_length:number;

end=b_array+number/c_int_bit;

for(;begin<end;begin++)
	for(n=1;n;n=n<<1)
		if((*begin)&n)all++;

i=number%c_int_bit;
for(n=1;i;n=n<<1,i--)if((*begin)&n)all++;
return all;
}


void bin::print(FILE *ou,int opt)
{
int i,o,first;

if(opt&2){
	o=option();
	for(i=0,first=1;i<b_length;i++)if((bit(i)&&o==1)||(!bit(i)&&o==-1)){
				if(first||i==(b_length-1)||bit(i+1)!=bit(i)){fprintf(ou,"%i",i+1);first=1;}
				if(first)fprintf(ou,"%s",bit(i+1)==bit(i)?"-":" ");
				first=0;
				}
				else
				first=1;
	}
	else
	for(i=0;i<b_length;i++)fprintf(ou,"%i",bit(i)?1:0);

if(opt&1)fprintf(ou," %i",all_on());
fprintf(ou,"\n");
}


//TABLE:

void table::prune(long no)
// This function remove column=no
{
double *elem,*old,*end;
long i=no;

TT if(no>=t_columns||no<0)error("In table::prune %i", no);

for(old=elem=t_elem,end=t_elem+t_columns*t_rows;old<end;old++,i--)
	{*elem=*old;
	if(i)elem++;
		else
		i=t_columns;
	}
//if(t_norm!=NULL)memcpy(t_norm+no,t_norm+no+1,sizeof(double)*(t_columns-no-1));
t_columns--;

if(t_norm!=NULL)memcpy(t_norm+2*no,t_norm+2*(no+1),2*sizeof(double)*(t_columns-no));

}

void table::reduce(table* t,bin* r1,bin *r2)
{
double *elem,*old,*end; long i=0;

t_columns=t->t_columns;

for(elem=t_elem,old=t->t_elem,end=old+t_columns*t->t_rows;old<end;old+=t_columns,i++)
		if((r2==NULL&&r1->bit(i))||(r2!=NULL&&!r1->bit(i)&&!r2->bit(i))){memcpy(elem,old,
				t_columns*sizeof(double));elem+=t_columns;}

t_rows=(elem-t_elem)/t_columns;
}


void table::reduce(table* t,int *vector)
{
double *elem,*old,*end; int i=0,j;

t_columns=t->t_columns;

for(elem=t_elem,old=t->t_elem,end=old+t_columns*t->t_rows;old<end;old+=t_columns,i++)
		if(vector[i]){
			for(j=0;j<vector[i];j++){memcpy(elem,old,t_columns*sizeof(double));elem+=t_columns;}
			}

t_rows=(elem-t_elem)/t_columns;
}


void table::print(FILE* ou,long r,double *rnorm)
{
long i;
double *elem=t_elem,*end=t_elem;

TT if(r>0)check_row(r);

elem+=(r<0)?0:r*t_columns;
end +=(r<0)?t_columns*t_rows:(r+1)*t_columns;

for(i=0;elem<end;elem++){if(*elem>=p_cut)fprintf(ou," *%*s",p_full-2,"");
								else
								fprintf(ou,"%*.*f ",p_full,p_float,rnorm==NULL?*elem:(*elem+rnorm[2*i])*rnorm[2*i+1]);
						fprintf(ou,!(++i%t_columns)&&r<0?"\n":"");
						}

}


long table::no_max(long col)
{
double *elem=t_elem+col,*end=t_elem+t_columns*t_rows,maxv;
long n,i;

TT check_col(col);

for(n=i=0,maxv=*elem;elem<end;elem+=t_columns,i++){
		if(maxv>p_cut){maxv=*elem;n=i;}
		if(maxv<(*elem)&&(*elem)<p_cut){maxv=*elem;n=i;}
		}

return n;
}


long table::no_min(long col)
{
double *elem=t_elem+col,*end=t_elem+t_columns*t_rows,minv;
long n,i;

TT check_col(col);

for(n=i=0,minv=*elem;elem<end;elem+=t_columns,i++)
	if(minv>*elem){minv=*elem;n=i;}

return n;
}


void table::norm_column(long col, double a, double b)
{
double *elem=t_elem+col,*end=t_elem+t_columns*t_rows;

TT check_col(col);

for(;elem<end;elem+=t_columns)*elem=*elem<p_cut?a*(*elem)+b:*elem;

t_norm=t_norm==NULL?new double[t_columns*2]:t_norm;

t_norm[2*col]=-b;
t_norm[2*col+1]=1./a;
}


bin *table::decorrelate(double correlation)
{
static bin *b;
int i,j;double c;

if(b!=NULL)delete b;

b=new bin(t_columns);

for(i=0;i<t_columns-1;i++)if(!b->bit(i))
	for(j=i+1;j<t_columns;j++)if(!b->bit(j)){c=cor_column(i,j);c=c<0?-c:c;
											if(c>=correlation){b->on(j);printf("\nColumn %i is pruned c=%f with column %i",j+1,c,i+1);}
											}

return b;
}



// The main statistical function. It calculates statistical parameters for all outputs
// together and for each output separately. Calculated values are stored in the output.


double *table::mean_columns()
{
double *values=NULL;
static memory_array array(0,values);
values=array.memory_d(t_columns);

for(long i=0;i<t_columns;i++)values[i]=mean_column(i);
return values;
}

double *table::disp_columns(double *means)
{
double *values=NULL;long i;
static memory_array array(0,values);
values=array.memory_d(t_columns);

for(i=0;i<t_columns;i++)values[i]=disp_column(i,means==NULL?(double*)NULL:means+i);

return values;
}


void table::extract_means()
{
double *means=mean_columns(),*v,*m,*stop,*end;
v=t_elem; end=t_elem+t_rows*t_columns;
stop=means+t_columns;
for(;v<end;)
	for(m=means;m<stop;m++,v++)*v-=*m;
}

void table::unit()
{
long i,j;
double *e;

for(i=0,e=t_elem;i<t_amount;i++,e++) *e=0.0;
for(i=0,j=0,e=t_elem;i<t_columns;i++,j++) *(e+(i*t_columns)+j)=1.0;
}


void table::multipnumber(double n)
{
double *elem, *stop;

for(elem=t_elem,stop=elem+t_amount; elem<stop;elem++) (*elem)*=n;
}


//DATA:
data::data(FILE* in,long r,long c,long val,long name)
:table(r,c)
{
long i,n,line_number,scan_number,elem_number,value_number;
bin *b;
char *str;
float a; double *d,*v,*v0;
unsigned long position;
str=new char[c_array+1];

value_number=val;

d_dat=new table(r,c);
if(val){
	d_val=new table(r,value_number);
	d_value=new table(r,value_number);
	v=d_value->row(0);
	}
	else
	d_value=NULL;

d_names=name?new pchar[r]:(char**)NULL;
elem_number=c+val+name;
d=row(0);

if(in!=NULL){
	for(i=0,line_number=1;i<r;line_number++)
		{
		n=0;
		position=ftell(in);
		if(feof(in))error("end of file has been achived, row=%i > %i",r,i);
		scan_number=field_scanf(in);
		if(scan_number){
			if(scan_number!=elem_number)break;
			if(name){fscanf(in,"%s",str);n=strlen(str);d_names[i]=new char[++n];strcpy(d_names[i],str);}
			for(n=0;n<c;n++,d++){if(fscanf(in,"%f",&a)!=1)goto a;*d=a;}
		 	if(d_value!=NULL){
		 		v0=v;
		 		for(n=0;n<val;n++,v++){if(fscanf(in,"%f",&a)!=1){n+=c;goto a;}*v=a;}
		 		}
			i++;
			}
		fgets(str,c_array,in);
		}

	if(i!=r){
		a:;
		fseek(in,position,SEEK_SET);
		fgets(str,c_array,in);
		error("scan error: line %i found %i need %i column=%i\n%s",line_number,scan_number,elem_number,n,str);
		}
	}
delete str;
}

data::~data()
{
long i;
delete d_dat;if(d_value!=NULL)delete d_val;
if(d_value!=NULL)delete d_value;
if(d_names!=NULL)for(i=0;i<rows();i++)delete d_names[i];
}


void data::print(FILE* ou,int no)
{
table *t=this;
int i;
i=no>=0?0:-1-no;
for(;i<rows();i++,fprintf(ou,"\n"))
	if(i!=(no-1)){
	if(d_names!=NULL)fprintf(ou,"%s ",d_names[i]);
	t->print(ou,i,t->renorm());
	fprintf(ou,"\t");
	if(d_value!=NULL)d_value->print(ou,i,d_value->renorm());
	if(no<0)i=rows();
	}
}

long data::name_length()
{
long i,n;
if(d_names==NULL)return 0;
n=strlen(d_names[0]);
for(i=1;i<rows();i++)n=n>strlen(d_names[i])?n:strlen(d_names[i]);
return n;
}


//DATASET:

dataset::dataset(char *file_name,long c,long v,long n)
{
FILE *in=mfopen(file_name,"r");
int i,*array;
char str[100];

if(in==NULL)error("data file %s is absent",file_name);

d_pruned=new int[c+1]; memset(d_pruned,0,sizeof(int)*c);d_pruned[c]=-1; // end of array

d_set=field_scanf(in);

if(d_set>=c_datasets){
		fgets(str,99,in);
		error("maximal number of datsets is %i >= %i in this file:\n%s",c_datasets,d_set,str);
		}

array=new int[d_set];

for(i=0;i<d_set;i++)fscanf(in,"%i",array+i); fgets(str,99,in);

for(i=0;i<d_set;i++)d_data[i]=new data(in,array[i]>0?array[i]:-array[i],c,array[i]>0?v:0,n);
fclose(in);
delete array;
}

dataset::~dataset()
{
for(int i=0;i<d_set;i++)delete d_data[i];
delete d_pruned;
}

// val - normalise or not output values
// min_v and max_v - boundary values
// set - how many datasets are used to calculate normalisation coefficients
//       it is usefull for re-calculation with previously saved weights

void dataset::norm(long val, long set, double min_v[2], double max_v[2])
{
int i,j,d,n;
double minimum,maximum,a,b;
table *t,*tt;bin bit((*d_data)->columns());

set=set<0?-set:d_set;

val=val?1:0;

for(i=0;i<2;i++)max_v[i]-=min_v[i];

for(val++,d=0;d<val;d++) // for inputs and outputs
{
	tt=d?(*d_data)->values():*d_data;
	n=tt->columns();

	for(j=0;j<n;j++)
		{
		minimum=tt->mmin(j);
		maximum=tt->mmax(j);

		if(minimum==maximum){
					if(d)error("constant value in output column=%i is not allowed",j+1);
					printf("\nWarning: constant value column %i is pruned",j+1);
					bit.on(j);}

		for(i=1;i<set;i++){
			t=d?d_data[i]->values():d_data[i];
			if(t!=NULL){a=t->mmin(j);
				minimum=(minimum<a)?minimum:a;
				a=t->mmax(j);
				maximum=(maximum>a)?maximum:a;}
			}
		maximum-=minimum;
		a=max_v[d]/(maximum?maximum:1);
		b=min_v[d]-minimum*a;

		for(i=0;i<d_set;i++){t=d?d_data[i]->values():d_data[i];if(t!=NULL)t->norm_column(j,a,b);}
		}
}

prune(bit);
}


void dataset::prune(bin &b)
{
int i,n,old;
for(old=n=columns(),n--;n>=0;n--)
	for(i=0;i<d_set;i++)if(b[n])d_data[i]->prune(n);
for(i=n=0;d_pruned[i]!=-1;i++)d_pruned[i]=(d_pruned[i]||!b[n++])?d_pruned[i]:old;

TT for(i=n=0;d_pruned[i]!=-1;i++)if(!d_pruned[i])n++; if(n!=columns())error("In prune!");
}

int dataset::check_pruned()
{
int i=0,*d;
for(d=d_pruned;*d!=-1;d++)if(*d)i++;
return i;
}


int dataset::print_pruned(int num,FILE**f)
{
int i,*d,number=check_pruned();
if(number)
	for(i=0;i<num;i++)if(f[i]!=NULL){
		fprintf(f[i],"\nThe next %i parameters were pruned:\n\t",number);
		for(d=d_pruned;*d!=-1;d++)fprintf(f[i],"%i ",*d);
		}
return number;
}


void dataset::print(FILE *ou,int no)
{
int i,n;

if(no<0)error("in dataset::print np=%i < 0",no);

for(i=0;i<d_set;i++){
		n=int(d_data[i]->values()==NULL?-d_data[i]->rows():d_data[i]->rows());
		if(no&&!i)fprintf(ou,"%i 1 ",n-1);
			else
			fprintf(ou,"%i ",n);
		}
fprintf(ou,"\n");

if(no>0){d_data[0]->print(ou,no);
	fprintf(ou,"\n");
	d_data[0]->print(ou,-no);
	for(i=1;i<d_set;i++)d_data[i]->print(ou);
	}
	else
	for(i=0;i<d_set;i++)d_data[i]->print(ou);
}

void dataset::statistic(FILE* ou)
{
int i;
fprintf(ou,"\ndatasets=%i\n",d_set);
for(i=0;i<d_set;i++)fprintf(ou,"%i rows=%i %s\n",i+1,int(d_data[i]->rows()),d_data[i]->values()==NULL?"-":"+");
}

long dataset::max_size()
{
int size,i;
size=take(0)->rows(); // lenght of basis table
for(i=1;i<d_set;i++)size=size>take(i)->rows()?size:take(i)->rows();
return size;
}

