//#define windows_application
static char* c_version = "version 04.04.98";

#include "analog.h"
#include <ctype.h>

dataset* input_data();
dataset* input_config(char*,long no);
void print_config(FILE*,int mode);

dataset  *data_set;
analog  *an_alog=NULL;

#ifdef windows_application
#include "stdafx.h"

nn_main()
{
int i;
time(&t_begin); // to fix a start of the programm

p_file[0]=mfopen("std_out", "w");//stdout;
p_file[1]=mfopen("comp","w");
p_out=p_file[2]=mfopen("out","w");

/* Please input values for these parameters  */

//data_set -pointer on the data set
data_set=NULL;
//p_rows     -amount of rows in the initial data
p_rows=0;
//p_columns  -amount of columns in the initial data
p_columns=0;
//p_n_output- number of column with target values p_n_output=1,2...p_columns
//              p_n_output=0; all columns will be analized as target
p_n_output=1;
//p_method   - method of analog complexation (can be =0,1,2)
p_method=0;
//p_print    -output information in file (can be =0,1,2)
p_print=1;
//p_grafic   -output (grafic=1) or not (grafic=0) the grafic
p_grafic=0;
//p_limit   - criterion for learning exit (usually limit=0.2-0.4)
p_limit=0.0;  // if p_limit 0.0 net

p_optimum=1; -// for begining optimization amount of parameters
              // (can be 0-turn off or 1)

#else // DOS version analog method

 main()
{
int i;
time(&t_begin); // to fix a start of the programm

p_file[0]=stdout; // mfopen("std_out", "w");//stdout;
p_file[1]=mfopen("comp","w");
p_out=p_file[2]=mfopen("out","w");

data_set=input_data();

#endif

// Main functions for analog method
       an_alog=new analog(p_layers,data_set);
       an_alog->gl_calculation();
       delete an_alog;

// Destroy the dataset object
	delete data_set;
	data_set=NULL;
	time(&t_current);
	for(i=0;i<3;i++)fprintf(p_file[i],"\ntime=%i",int(t_current-t_begin));

for(i=1;i<3;i++)fclose(p_file[i]);
return 0;
}


dataset* input_data()
{
int i;
double min_norm[2],max_norm[2],*e,maxerror;
dataset *data_set;

config_number=0;

init_param(); //read the parameters
qsort(global_param,c_param_number,sizeof(param),compare_param);
copy_parameters(save_param,global_param); // to save default values of parameters

        data_set=input_config("cfg",config_number);
        if(data_set==NULL)error("Input data file is absent");
	for(i=0;i<3;i++)print_config(p_file[i],i==2);
	data_set->decorrelate(p_max_correlation);
	if(p_norm){
		p_min_input=min_norm[0]=range_funact(c_exp,0); p_min_output=min_norm[1]=range_funact(c_exp,0);
		p_max_input=max_norm[0]=range_funact(c_exp,1); p_max_output=max_norm[1]=range_funact(c_exp,1);
		data_set->norm(p_normv,p_norm,min_norm,max_norm);	// how many datasets should be used for min/max operation
		}
	*p_layers-=data_set->print_pruned(3,p_file);

return data_set;
}



dataset* input_config(char *name, long previous)
{
FILE *in=mfopen(name,"r");
long i,len,count=0,n,stop,p_layers_number_tmp=-1,rows;
unsigned long position=0,possave;
char s[100],*s1,*ss;

s1=new char[c_array+1];

copy_parameters(global_param,save_param); // to restore default values of the parameters

if(in==NULL)error("Could not open %s file",name);

while(!feof(in))
{
	*s1=*s=0; fscanf(in,"%s",s1);
	possave=position;
	position=ftell(in)-strlen(s1);
	if(*s1=='#'){fgets(s1,c_array,in);continue;}

	for(ss=s1;*ss;ss++)if(*ss=='='){*ss=' ';break;}
						else
						*ss=toupper(*ss);
	sscanf(s1,"%s",s);
	len=strlen(s); ss=s1+len+1;

	if(strstr(s,"END")&&len==3)return NULL;

	if(strstr(s,"STOP")&&len==4){fgets(s1,c_array,in);
		if(count==previous)break;
			else
			{count++;continue;}
		}

	// an input of some special keywords

	if(strstr(s,"DATAFILE")&&len==8){sscanf(ss,"%s",file_name);continue;}

	if(strstr(s,"INCLUDE")&&len==7){
		sscanf(ss,"%i",&p_mask);
		p_bmask=new bin(*p_layers,in);
		if(p_mask>0)p_bmask->invert();
		p_mask=1;
		continue;
		}

	if(strstr(s,"LAYERS")&&len==6){
		if(sscanf(ss,"%i",&p_layer_number)!=1)goto err;
		if(p_layer_number>c_layers)error("The indicated number of layers=%i exceeds allowed=%i",p_layer_number,c_layers);
		memset(p_layers,0,c_layers*sizeof(long));
		for(i=0;i<p_layer_number;i++)if(fscanf(in,"%i",p_layers+i)!=1)goto err;
		continue;
		}

	if(len){for(i=stop=0;!stop&&i<c_param_number;i++)stop=global_param[i].input(s,ss);
			if(i>=c_param_number&&!stop)goto err;}
}
fclose(in);

if(p_layers_number_tmp!=-1&&p_layers_number_tmp!=p_layer_number)error("The number of layers is %i while it was %i for funact\nPossible error: FUNACT is before LAYERS in %s file",p_layer_number,p_layers_number_tmp,name);

if(count!=previous)error("operator END is absent");

data_set=new dataset(file_name,*p_layers,p_layers[p_layer_number-1],p_name);
if(p_mask){data_set->prune(*p_bmask);p_bmask->invert();}

// some checks, additional checks of parameters can be added
compare_parameters(global_param,save_param);

time(&t_current);

delete s1;
return data_set;

err:
fseek(in,possave,SEEK_SET);
fgets(s1,c_array,in);ss=s1+strlen(s1);fgets(ss,c_array,in);
error("error in input_config in one of the next strings:\n%s",s1);
return NULL;
}


void print_config(FILE*out,int mode)
{
struct tm *date; char s[200];
int i,n;
time(&t_current); date=localtime(&t_current); strftime(s,80,"%c",date);
//fprintf(out,"\n\n%s %s | time=%i", c_version, s,int(t_current-t_begin));
fprintf(out," %s\n",*environment?environment:"");
fprintf(out,"\nDATAFILE=%s",file_name);
fprintf(out,"\nLAYERS=%i ",p_layer_number);
for(i=0;i<p_layer_number;i++)fprintf(out,"%i ",p_layers[i]);
fprintf(out,"\n");
if(p_mask){fprintf(out,"INCLUDE=%i ",p_bmask->option());p_bmask->print(out,2);}
for(i=0,n=2;i<c_param_number;i++)global_param[i].print(out,n,mode);
data_set->statistic(out);
}
