CĿ
C     Name: Catch_No                                         06.06.99 21:53pm 
C                                                                             
C     Description: Calculate model values by given model no Nm.               
C                                                                             
C     Gregory Ivakhnenko, (c)                                                 
C

      subroutine Catch_No ( Kl,M0,NT,nVars,Srq,Var,X,XT,AA,SNor,C,B,CO,
     +                      VN,VNy, Im,In, IAn )
      real		   X ( ML,N ),      AA( ML1,N ),  XT ( M0,NT )
      real*8         SNor( ML1,ML1 ), C( ML1,ML1 ), B( ML1,ML1 ),
     +               CO  ( ML1 ),     VN( N ),      VNy( N ) 
      integer        IAn ( ML11 ),    nVars
      integer*2      Im ( 600 ),		In ( N ),	  Kll
      real*8         S, Var, Srq
	integer		   I,J,L, II,JJ

      common /LMai1/ JRes,   JFile,  JGraph,  JNorm,  JProt,  LFor,
     +               LAn,    LTest,  LSel
      common /LMai2/ JFun,   JS,     JRegul,  ISe,  ICr, JDiv
      common /LSize/ ML, ML0, ML1, ML11, N, LF, MV,MV1,MV2, Qmax
      automatic

	S = Qmax
100	CO = 0.
	Kll = 0
	Kl  = 0
	nVars = count( IAn /= 0, dim=1 )

	if( JRegul == 2 ) call Balan(Kl,nVars,S, X,AA,SNor,B,C,CO, IAn)
	if( Kl .ne. 0 ) return                   ! Model can't be calculated
C------------------------------------------------------------------------
      
	do 10 I= 1,N							  ! on all observations
	   AA( 1,I ) = 1.
         AA( nVars+2,I ) = X( ML0,In( I ))      ! write function at right column
         do 10 J= 1,nVars                       ! create AA array
10          AA( J+1,I ) = X( IAn( J ),In( I ))  ! by current variables ansamble

      call Reg8 ( Kl, nVars+1,nVars+2, N, ML1, B,C,SNor, AA, CO )
      if ( Kl .ne. 0 ) return                   ! Model can't be calculated

	do 60 I= 2,nVars+1
		if( abs( CO( I )) .le. 1.E-5 ) then	  ! Cut terms with coefficients less than threshold
			Kll = Kll + 1
			IAn( I-1 ) = 0					  ! Remove corresponding variables
60	endif

	do 70 I= 1,Kll							  ! compact IAn
		do 70 J=1,nVars-1
			if(  IAn( J ) == 0 ) then
				IAn( J:nVars-1 ) = IAn( J+1:nVars )
				IAn( nVars ) = 0
			endif
70	continue
	if( Kll .ne. 0 ) goto 100

!------------- Calculate second criterion value -----------------------
	do 20 I= 1,N
         VN( I ) = CO( 1 )
         do 20 J= 1,nVars                       ! Calculate model value
20          VN( I ) = VN( I ) + X( IAn( J ), I ) * CO( J+1 )
	
	S = 0.		
	if( JRegul == 1 ) then					  ! Variation
			do 80 I= 1,N                           ! RR  
80			S  = S + ( VNy( I ) - VN( I )) **2    !! Renormilized values

		if( Srq .ne. 0.)  S = sqrt( S )/ sqrt( Srq )
		Var = S / dble( N )					  ! get average	

	elseif( JRegul == 0 ) then				  ! MAPE
          do 40 I= 1,N
40		if( VNy( I ).ne. 0) 
     +		S = S + abs(( VNy( I ) - VN( I ))/ VNy( I )) 
		Var = S / dble( N )					  ! get average	

	elseif( JRegul == 3 ) then				  !AR_C

         if( LFor .ne. 0 )  then                ! Calculate forecast
		   L = 0
	       do 90 II = 1,NT                    ! All test points
			 Kll = 0
               Var = CO( 1 )
               do 110 I= 1,nVars
                  J = Im( IAn( I ))         
				if( J < 0 ) J = -J			  ! Is function(var) is in ansamble?
!			    J  = J - 1					  ! delayed-1
                  JJ = J / 100                  ! Receive var no.
                  J  = J - JJ*100               ! Receive var argument no.
                  J  = II - J					  ! make shift
                  if( J > 0 ) then			  ! if delay inside subsample
					Var = Var + XT( JJ,J ) * CO( I+1 )	! calc forecast
				else 
					Kll = 1					  ! cannot calculate output value
					exit					  ! because delayed value is out of XT sample
110				endif

			if( Kll == 0 ) then				  
				S = S + ( XT( -Im( ML ),II ) - Var )**2
				L = L + 1					  ! count calculated points
90			endif

		else
			do I= 1,NT						  ! approximation
				S = S + ( XT( -Im( ML ),I ) - CO( 1 )	
     +			- sum( XT( IAn(1:nVars),I ) * CO(2:nVars+1)) )**2 ! Calculate model value
			end do
			L = NT
		endif
		
		if( L /= 0 ) then
			Var = S / dble( L )				  ! average AR_C value
		else
			Var = Qmax						  ! output cannot be calculated on XT
			Kl = 1
		endif
	endif

      return                                    ! Exit to next best model
      end

!		Y = sum ( invector(:nCoef-1) * this%aCoef(2:) ) + this%aCoef(1)
C         Var = sqrt(S / N)                     !! MSE
C       else
C          Var = Qmax
C       endif
C      write (*,*) 'variation',S,Srq,Var
C       S = sqrt(S/N)
C      Var  = (SS - S) / ( Srq**2 )              !! max
C      Var  =  SS - S                           !! max

!      if( JNorm .ne. 0 ) then                   !!!!!!! Renormilize VN
!         S = RMax( ML0 ) - RMin( ML0 )
!         do 30 I= 1,N
!30          VN( I ) = ( VN( I ) * S ) + RMin( ML0 )
!      endif