CĿ
C     Name:  Combi.h                                         10-11-95 06:00pm 
C                                                                             
C     Description:  Definitions of the external functions                     
C                   and descriptions of the program variables                 
C                                                                             
C     Gregory Ivakhnenko  (c)                                                 
C
      interface to function  SetVideoMode (mode)
      integer*2  SetVideoMode [Far,C,Alias:"__setvideomode"], mode
      end

      interface to function  Any_Key ()
      integer*2  Any_Key [C]
      end

      interface to function  Get_Key ()
      integer*2  Get_Key [C]
      end

C
C Constants descriptions:
C   N   - number of observations
C   M   - number of variables
C   MY  - number of functions (outputs)
C   MM  - maximal number of variables (array size)
C   NN  - maximal number of observations (array size)
C   LF  - maximal number of variables ensembles
C   M0,MQ - initial number of variables
C   NT  - number of points for test of the model
C   No  - number of all ensembles
C   Lan - number of ensembles selected at each layer
C   NCr - no. of selected criterion value
C   ML  - maximal number of variables + functions (ML = M + MY)
C   ML0 - initial function column no.
C   ML11- variables limit column no.
C   ML1 - number for allocation of AA,SNOR
C
C   Crit      - criteria names vector
C   On_Off    - 'On' and 'Off'
C   Rep_name  - report file name
C   Card_name - parameter card name
C   Name_In   - data file name
C   Format    - data input format
C   Form, VarForm, VarName, VarName2, GrName, Xname, Yname, Yname2 - formats
C               and strings used in graph
C   QMax      - biggest number
C
C Arrays:
C   X   (ML, N)  - initial data array
C   XT  (MQ,NT)  - array for hidden points for test of the model
C   AA  (ML1,N)  - conditional equations array
C   SNor(ML1,ML1)- normal equations array
C   B   (ML1,ML1), C (ML1,ML1) - additional array for coefficients calculation
C
C Vectors:
C   CO  (ML1)    - coefficients vector for one ensemble
C   CR  (LF)     - vector of selected min of criterion for all Y  ( LAn x LCut )
C   IAq (LF)     - no. of selected models at all layers
C   ISel(ML11,LAn2) - vector for save of selected ansambles
C   Iy  (30)     - tmp vector for functions Y input
C   Im  (300)    - vector of real variables no.
C   In  (N)      - vector for points selection into subsamples for regularity crit.
C   RMax(ML), RMin(ML) - extremum vectors for data columns
C   IAn (ML11)   - tmp variables ensemble
C   IMq (ML11)   - number of ensembles for each M vector
C   IMs (ML11)   - selected variables after 5 layer
C   Vab (15)     - vector for selecting of the best model
C   In_Card (12) - parameters vector
C   Im  (300), In(N), Iy(30) - vectors of selected no. of variables, points, functions
C   Q   (300)    - vector for reading of points from data file
C   IProt(300)   - vector of protected variables
C   Vn  (N)      - tmp calculated function vector
C   Vny (N)      - current function vector
C   Vm  (ML11)   - vector for output of CR minimums in graph
C
C Variables:
C   MV    - current no. of layer
C   i100th, iyr, imon, imin, i100th2, iday, isec, imin2, ihr, isec2, ihr2 -
C         - time variables
C   io    - tmp stream no.
C   FNO   - report file stream no.
C
C Keys (1/0):
C   LFor   - approximation/prediction mode (number of delayed arguments used)
C   LAn    - number of ansambles selected at each layer
C   LTest  - number of hidden points for test of the model
C   JNorm  - normilize initial data
C   JFun   - use functions as variables
C   JS     - cancel procedure by criteria value raising
C   JRegul - regularization mode no.
C   JGraph - draw graphs of model values
C   JFile  - create results file
C   JRes   - output of the additinal results
C   JPr    - level of results output
C   JProt  - protection of variables
C   ICr    - no. of criterion used
C
C  Subroutines:
C MODEL    - main submodule, sorting-out of layers of models
C CARDY_1  - input of parameters from file 'Card_Name',
C            autodetect no. of points  (first part)
C CARDY_2  - input of parameters from file 'Card_Name' (second part)
C DATYPIN  - input of data array
C DELAYARG - create delayed variables array
C GET_ARGS - analyse command string arguments, gives help information
C
C MATPRIA, MATPRIAF - write arrays
C NORMIMAX - normilize data
C VI2PRI   - write vectors
C Any_key  - wait for key pressed
C
C                     M   ML=M+MY
C            XĿ              VNĿ
C Data array:            LT -teach ss.   
C             Ĵ                 
C             Ĵ\LCh-check ss.   
C                       NT               
C             N  \ test ss.   N
C                                            \tmp vector for output
C           CRĿ
C              \criteria min for all ansambles
C                LAn           LF
C           COĿ
C             
C                          ML1
C          IMqĿ
C               - number of ansambles for each M
C          IAnĿ
C               - current ansamble
C           ImĿ
C               - real numbers of the variables
C                        ML11
C
C Limits:
C  1 < M < 300, MY < 30, 3 < N < 30000,  LCh < 100,  LTest < N
C
C
