CĿ
C     Name: Corel                                            18.06.99 15:47pm 
C                                                                             
C     Description: Calculation of correlation criterion.                      
C                                                                             
C     Gregory Ivakhnenko (c)                                                  
C

      subroutine  Corel ( Kl, LT,LCh,S, X,AA,SNor,SNorm,B,C,CO,
     +					VN,VNy, In,IAn)
      real        X   ( ML,N ),    AA( ML1,N )
      real*8      SNor( ML1,ML1 ), SNorm( ML1,ML1 ), C ( ML1,ML1 ), 
     +			B( ML1,ML1 ),    CO  ( ML1 ), VNy( N ), VN( N )
      real*8		S,Sr
      integer     IAn ( ML11 )
      integer*2   In  ( N )
!      logical*1   Kll
      common /LSize/  ML,ML0,ML1,ML11,N,LF, MV,MV1,MV2, Qmax
      automatic

! Calculate model for training subsample A
	forall( I=1:MV )
		SNorm( I+1,  1 ) = SNor( IAn( I )+1,   1 ) ! form first row of XtX
		SNorm( MV2,I+1 ) = SNor( ML1, IAn( I )+1 ) ! form XtY column
	end forall
	
	forall( I=1:MV )
		forall( J=1:I )
			SNorm( I+1,J+1 ) = SNor( IAn( I )+1,IAn( J )+1 ) ! form column J
		end forall
		SNorm( 1:I,I+1 ) = SNorm( I+1,1:I )					 ! copy to row I
	end forall

	call Chol ( Kl, MV1,MV2, ML1, SNorm,B,C, CO )	! estimate coefficients
      if( Kl .ne. 0 ) return         

! Calculate criterion for test subsample B
      forall ( I= 1:LCh )  
     +	VN( I ) = CO( 1 )+ sum( X( IAn(1:MV),In( I+LT )) * CO(2:MV1))   ! Calculate model value

	Sr = sum( VN(:LCh) )/LCh
	VN(:LCh) = VN(:LCh) - Sr

      S  = sum(  AA( 1,:LCh ) * VNy(:LCh ))			! Covariation
      Sr = sum(( AA( 1,:LCh )**2 ) * ( VNy(:LCh)**2 ))

      if( Sr == 0.) then
		S = 1.
      else
          S = 1 - abs(S / sqrt( Sr ))					! Correlation coefficient
      endif

      return
      end