CĿ
C     Name: Res_Out                                          30.06.97 19:35pm 
C                                                                             
C     Description: Output of the results                                      
C                                                                             
C     Gregory Ivakhnenko  (c)                                                 
C

      subroutine  Regul (io, M0,NT,X,XT, AA,SNor,C,B,CO,CR,
     +           nSelModels, RMin,RMax, VN,VNy,ForVal, Im,In, SelAn,IAn)
      real
     +            X  ( ML, N ), XT  ( M0,NT ),
     +            AA ( ML1,N ), RMin ( ML ), RMax ( ML )
      real*8
     +            SNor (ML1,ML1), C (ML1,ML1), B (ML1,ML1), CO (ML1),
     +            CR  ( LF ),     ForVal( 2,NT ),
     +            VN ( N ),		VNy ( N )
      integer     IAn ( ML11 ),   SelAn ( LF,ML11 )
      integer*2   Im ( 600 ),     In ( N ),    InMin( 100 )

      real*8          SS, Sr,Srq, CR1,CR2,CR3, Var
	integer::		I,N,K,KI,KL,nVars

      common /LDat/   JPr
      common /LMai1/  JRes,    JFile,   JGraph,   JNorm,  JProt,  LFor,
     +                LAn,     LTest,    LSel
      common /LMai2/  JFun,    JS,      JRegul,   ISe,  ICr, JDiv
      common /LSize/  ML, ML0, ML1, ML11, N, LF,  MV,MV1,MV2, Qmax

	InMin = 0
C**********************************************************************
C           Calculate deviation from linear trend
C**********************************************************************
	VNy(:)   = X( ML0,: )						! Save VNy - function
	Sr = sum( VNy(:)) / N						! Calculate average of function
	
	if (LFor /= 0 ) then
		Srq = 0
		do 50 I= 1,N-1
			Srq = Srq + ( X( ML0,I ) - X( ML0,I+1 ))**2
			AA ( 2,I ) = X( ML0,I )					! Forming of AA array
50			AA ( 3,I ) = X( ML0,I+1 )
		call REG8 ( Kl, 2,3,N-1, ML1, B,C,SNor,AA, CO )! Found autocorellation coefficients
	else
		do 55 I= 1,N
			AA ( 2,I ) = I
55			AA ( 3,I ) = X( ML0,I )
	    call REG8 ( Kl, 2,3,N, ML1, B,C,SNor,AA, CO )! Found linear trend coeficients
	
		SS  = 0.
		Srq = 0.
		if( Kl .eq. 0 ) then						! if solved
			write (*,99) ( CO( I ), I= 1,2 )        ! trend coefficients
			if( JFile .ne. 0 ) write (io,99) ( CO( I ), I= 1,2 )

			do 250 I= 1,N
				SS = CO( 1 ) + I * CO( 2 )                   ! Calculate model value
250				Srq = Srq + (( X( ML0,In( I )) - SS )** 2 )  ! Quadrat of deviation from trend
		else
			do 270 I= 1,N
270				SS = SS + ( VNy( I ) - Sr )** 2		! Quadrat of deviation from average     
			Srq = SS
		endif                                                
	endif
! 290   Sre = S / N								! - error of naive forecast
C**********************************************************************
C           Write minimal criterion and select 100 minimal values of CR
C**********************************************************************
      if( JFile .ne. 0 ) then
         write (io,*)
         write (io,88)
      endif

      if( JPr .ne. 0 ) write (*, 88)    
C-----------------------------------------------------------------------------
 	call RaPIVe ( 100, LF,100, CR,InMin )	! Range CR vector of the best models
											! IMs contain no. of best models in SelAn
       if( JRegul .eq. 4 ) then				! skip regularization
		Var = CR( InMin( 1 ))				! only 1 mininum CR
		IAn(:) = SelAn( InMin( 1 ),: )		     
		call Catch_No ( kl,M0,NT,nVars, Srq,Var, X,XT,AA,SNor,C,B,CO,
     +	                VN,VNy, Im,In,IAn )

	   	call Res_Out (io, Var,SR, 1,InMin(1), M0,NT, XT, 
     +	   			  CO,CR, RMax,RMin, VN,VNy,ForVal, Im, IAn )
		return
      endif
C**********************************************************************
C           Select several models according to second criterion
C**********************************************************************
      SS  = Qmax                                  ! Global Var_min
      CR1 = Qmax								    ! Var_min 1
      CR2 = Qmax		                            ! Var_min 2
      CR3 = Qmax			                        ! Var_min 3
      K   = 0                                     ! Selected model no.
      KI  = 0                                     ! No. of selected models
C**********************************************************************
C       Regularization (extended model definition) by discrimination criterion
C**********************************************************************

      do 100 while ( K < min0( 100,nSelModels ))	! Global loo with selected models

		K = K + 1
		IAn(:) = SelAn( InMin( K ),: )			! Get ansamble
		call Catch_No ( kl,M0,NT,nVars, Srq,Var, X,XT,AA,SNor,C,B,CO,     ! Calculate cr value - Var
     +                    VN,VNy, Im,In,IAn )
		if( kl .ne. 0 ) cycle					! Not solved - next CR_min

		! Catch local minimum of second criterion
		if(((Var - CR1).le. 1.E-5 .OR. (Var - CR2).le. 1.E-5 )) then
			CR2 = CR1                               ! Var > CR1  CR2 - found next
			CR1 = Var
		else
			exit
		endif

		if( Var < SS ) then 
			! Output of intermediate models
			if( JRes .ne. 0 ) then				! Write only one model if JRES=0
      			call Res_Out (io,Var,SR, K,InMin(K), M0,NT,XT, 
     +						  CO,CR, RMax,RMin,VN,VNy,ForVal,Im,IAn)
			endif
			SS = Var							! Save minimal Variation
			KI = K
		endif
100   continue
	
	if( CR1 == Qmax ) then
		write( io,* )'    * Cannot solve any system! *'
		return
	endif
C**********************************************************************
C       Output of results
C**********************************************************************
	if( JRes .eq. 0 ) then

		IAn(:) = SelAn( InMin( KI ),: )			! Get ansamble
		call Catch_No ( kl,M0,NT,nVars,Srq,Var, X,XT,AA,SNor,C,B,CO, ! Calculate cr value - Var
     +                    VN,VNy, Im,In,IAn )
		if( kl == 0 )				
     +	call Res_Out (io, Var,SR, KI,InMin(KI), M0,NT, XT, 
     +				  CO,CR, RMax,RMin, VN,VNy,ForVal, Im, IAn)

		! Output of the first model, selected by the first criterion
		if( JPr .gt. 0 .and. KI .ne. 1 ) then

			IAn(:) = SelAn( InMin( 1 ),: )   
			call Catch_No( kl,M0,NT,nVars,Srq,Var,X,XT,AA,SNor,C,B,CO,
     +	                    VN,VNy, Im,In,IAn )
			if( kl == 0 )				
     +   		call Res_Out (io, Var,SR, 1,InMin(1), M0,NT, XT, 
     +	     			  CO,CR, RMax,RMin, VN,VNy,ForVal, Im, IAn)
		endif

	elseif( KI .ne. 1 ) then

         write (*,555)
         if( JFile  .ne. 0 )  write (io,555)

	endif

      return
88    format (/, ' Best models :')
555   format(/5X,'*  The last model was selected by second criterion *')
99    format (/,3X,'Trend of output:    y =',
     +              E14.7,' + ',E14.7,' * x')
!88    format (   2X,'is substracted from output' )
      end



!      if( JRegul .eq. 1 ) then                              ! normal regularization mode
!         if(( CR1-Var ) .le. -1.E-7  .or.  CR1 .ge. CR2     !? ge, eq not work
!     +      .or. abs( CR1-CR2 ) .le. 1.E-7 ) then           ! variation grow up?
!            CR2 = CR1                              ! Var > CR1  CR2 - found next
!            CR1 = Var
!            cycle                                  ! Next model with next variation
!         endif
!      else                                         ! dafault - more accurate regularization
!         if(( CR1-Var ) .le. -1.E-7  .or.  CR1 .ge. CR2       !? ge, eq not work
!     +      .or. abs( CR1-CR2 ) .le. 1.E-7  .or. CR2 .gt. CR3 ) then   ! more accurate
!            CR3 = CR2                              ! Var > CR1  CR3 - found next
!            CR2 = CR1                              ! Var > CR1  CR2 - found next
!            CR1 = Var
!            cycle                                  ! Next model with next variation
!          endif
!         if( Var .gt. CR1 .or. Var .gt. CR2 .or. CR1 .eq. CR2 .or.
!     +       CR1 .gt. CR3 )  then   ! more accurate