$LARGE
CĿ
C     Name: SolveMxN                                         04/04/93 03:33pm 
C                                                                             
C     Description:  Solve system of linear equations MxN                      
C                                                                             
C     Gregory Ivakhnenko (c)                                                  
C
         include       'FGRAPH.FI'
      Program  SolveMxN
         include       'FGRAPH.FD'
      real     X  [allocatable] (:,:),
     +         B  [allocatable] (:,:),  C   [allocatable] (:,:),
     +         AA [allocatable] (:,:),  SNor[allocatable] (:,:),
     +         CO [allocatable] (:),
     +         Out [allocatable] (:),   Y [allocatable] (:)
      real          Par_Card( 1 ), Var( 1 )
      real     S,SS
      integer       In_Card ( 2 ), IM ( 100 ), IN( 300 ), MM,NN, NVar

      character*9    Yname, Xname
      character*10   VarForm
      character*12   QForm,  Yname2
      character*20   VarName, VarName2
      character*30   GrName
      logical        Mode
      external       Mode

      character*12   Name                  ! File name (for input)
      character*10   Form                  ! Input format

      common /LDat/  JPr                   ! Print initial data key
      common /LReg/  JReg, JCoef
      common /LGraf/ VarForm, VarName, VarName2, GrName, Xname,
     +               Yname,   Yname2,  QForm
      automatic                            ! Put everything on stack by default
C-----------------------------------------------------------------------------
C
C-----------------------------------------------------------------------------
      VarForm = '(F7.4)'
      QForm   = '(F9.3)'
      Yname   = 'Approx.Y '
      Yname2  = 'Real Y'
      GrName  = ' Results of the approximation '
      Xname   = '    Point'
      VarName = 'Mean abs. deviation='
      VarName2= 'Mean square deviat.='

C
C           Size  of  data  and  parameters  input
C
      NVar = 1
      call Card_In ( NVar, Name,Form, M,N, MM,NN, IM,IN,
     +               Par_Card,1,      In_Card,2, Var )       ! Card input

      JPr   = In_Card( 1 )                ! initial data print key
      JFile = In_Card( 2 )                !

      write (*,'(/10X,A31,I2)') 'Initial data print key   JPr =', JPr
      write (*, '(10X,A31,I2)') 'Output to file key     JFile =', JFile
      write (*,*)
C
C           Memory allocation
C
      M1 = M + 2
      allocate( X (  M,N ), CO  ( M1 ), Out( N ), Y( N ),
     +          AA( M1,N ), SNor( M1,M1 ), B( M1,M1 ), C( M1,M1 ),
     +          stat = MemErr )
      if( MemErr .ne. 0 )  stop 'Abort: Not enough storage !'

      call DatPIn ( Name, Form, M,N, MM,NN, X, IM,IN )      ! Data array input
C
C
C
      do 90 I= 1,N
         AA( 1,I ) = 1.                          ! Initialize first column of AA array
         AA( 2,I ) = X( 1,I )                    ! by current variables ansamble
         AA( 3,I ) = X( 1,I )**2.
         AA( 4,I ) = X( 2,I )
90        Y( I )   = X( 2,I )

      call REG  ( Kl, M+1,M1, N, M1, B,C,SNor, AA, CO )

      if( Kl .ne. 0 ) stop '*  System not solved !  *'

      write ( *,111 ) ( CO( J ), J= 1,M+1 )

      S  = 0.
      SS = 0.
      do 10 I= 1,N
         Out( I ) = CO( 1 ) + X( 1,I )*CO( 2 ) + CO( 3 )* X( 1,I )**2
         AA( 4,I ) = Out( I ) - X( 2,I )
         S  = S + abs( AA( 4,I ))
         SS = SS+    ( AA( 4,I ))**2
         AA( 3,I ) = Out( I )
         AA( 2,I ) = X( 2,I )
10       AA( 1,I ) = X( 1,I )

      S  = S / N
      SS = sqrt( SS/( N-1 ))
      if( JPr .ne. 0 ) then
         call MatPri ( 4,N, M1,N, AA )
         write (*,*) 'Mean absolute deviation =', S
         write (*,*) 'Mean square   deviation =', SS
         write (*,*)
      endif
C-----------------------------------------------------------------------------
C
C-----------------------------------------------------------------------------
      if( JFile .ne. 0 ) then
         open ( 2, file='OUT', status='UNKNOWN', mode='WRITE', err=9999)
            write ( 2,* ) '   Data array:'
               do 60 I= 1,N
60             write ( 2,Form ) ( AA( J,I ), J= 1,4 )
            write ( 2,* )
            write ( 2,111 ) ( CO( J ), J= 1,M+1 )
            write ( 2,* )
            write ( 2,* ) 'Mean absolute deviation =', S
            write ( 2,* ) 'Mean square   deviation =', SS
         close ( 2 )
      endif
C-----------------------------------------------------------------------------
C
C-----------------------------------------------------------------------------
      PAUSE
      if( MODE ()) then                  ! Set graphics mode
         stop ' Sorry, this program requires a graphics card !'
      endif
      dummy = Init_Axe ()
      Ymin = 0.
      Ymax = 0.
      call GRAF ( 2, 0, 1, S,SS, Ymin,Ymax, 1,N, 1,N, N,N, Out, Y )
      dummy = setvideomode( $DEFAULTMODE )

      write (*,*)
      if( JFile .ne. 0 ) write (*,*) 'Look for results into file  OUT.'
C------------------------------------------------------------------------------
C           End of the program
C------------------------------------------------------------------------------
      deallocate ( X, CO, AA, SNor,B,C, stat = MemErr )
      if( MemErr .ne. 0 )  write (*,*) ' Warning: Deallocation error!'
      stop ' '

111   format ( 10X,'Coefficients :',/,100E12.5 )
9999  write(*,'(/,3A)')' *** Error in the opening of the file !***'
      stop ' '
      end
