C$LARGE
CĿ
C     Name: SolveMxN                                         04/04/93 03:33pm 
C                                                                             
C     Description:  Solve system of linear equations MxN                      
C                                                                             
C     Gregory Ivakhnenko (c)                                                  
C

      Program  SolveMxN
      real     X  [allocatable] (:,:),  AA [allocatable] (:,:)
      real*8   B  [allocatable] (:,:),  C  [allocatable] (:,:),
     +         SNor[allocatable] (:,:), CO [allocatable] (:)
      REAL*8   S,SS
      real          Par_Card( 1 ), Var( 1 )
      integer       In_Card ( 2 ), IM ( 100 ), IN( 300 ), MM,NN, NVar
      character*12  Name                  ! File name (for input)
      character*10  Form                  ! Input format

      common /LDat/ JPr                   ! Print initial data key
      common /LReg/ JReg, JCoef
C      automatic     I,J                   ! Put everything on stack by default
C
C           Size  of  data  and  parameters  input
C
      NVar = 1
      call Card_In ( NVar, Name,Form, M,N, MM,NN, IM,IN,
     +               Par_Card,1,      In_Card,2, Var )       ! Card input

      JPr   = In_Card( 1 )                ! initial data print key
      JFile = In_Card( 2 )                !
      write (*,*) M,N

      write (*,'(/10X,A31,I2)') 'Initial data print key   JPr =', JPr
      write (*, '(10X,A31,I2)') 'Output to file key     JFile =', JFile
      write (*,*)
C
C           Memory allocation
C
      M1 = M+1
      allocate( X ( M ,N ), CO  ( M1 ),
     +          AA( M1,N ), SNor( M1,M1 ), B( M1,M1 ), C( M1,M1 ),
     +          stat = MemErr )
      if( MemErr .ne. 0 )  stop 'Abort: Not enough storage !'

      call DatPIn ( Name, Form, M,N, MM,NN, X, IM,IN )      ! Data array input
C
C
C
      do 90 I= 1,N
         AA( M1,I ) = 0.                         ! Initialize first column of AA array
         do 90 J= 1,M                           ! Creating AA array
90          AA( J,I ) = X( J,I )              ! by current variables ansamble

C      if( M .ne. N ) then
C         call REG8  ( Kl, M,M1, N, M1, B,C,SNor, AA, CO )
C      else
C         if( JPr .ge. 2 ) then
C            write (*,*) ' AA :'
C            call MatPri ( M1,N, M1,N, AA )
C         endif
C
         call KHAL8 ( Kl, M,M1, M1, AA,B,C, CO ) ! M=N Solve without normal array
C      endif
      if( Kl .ne. 0 ) stop '*  System not solved !  *'

      write ( *,111 ) ( CO( J ), J= 1,M )
C      write (*,*) M,M1
C      write ( *,* ) ( CO( J ), J= 1,M )

      SS = 0.
      SSS = 0.
      do 30 I= 1,N
         S = CO( 1 )
         do 20 J= 1,M-1                            ! Calculate model value
C            write (*,*) X( J,I ), CO( J+1 ),S
20          S = S + X( J,I ) * CO( J+1 )

C         write (*,*) X( M,I ), S               ! Sum of criteria
         SS = SS + (( X( M,I ) - S )** 2 )    ! Sum of criteria
30       if( X(M,I) .ne. 0)
     +            SSS = SSS + abs(( X( M,I ) - S )/ X( M,I ))    ! Sum of criteria

      SS = SS / N
      SSS = SSS*100 / N
      write (*,*)
      write (*,*) ' MSE=',SS,'    MAPE=',SSS

      if( JFile .ne. 0 ) then
         open ( 2, file='OUT', status='UNKNOWN', mode='WRITE', err=9999)
            write ( 2,* ) '   Data array:'
               do 60 I= 1,N
60             write ( 2,Form ) ( X( J,I ), J= 1,M )
            write ( 2,* )
            write ( 2,111 ) ( CO( J ), J= 1,M )
            write (2,*)
            write (2,*) ' MSE=',SS,'    MAPE=',SSS
         close ( 2 )
      endif
C------------------------------------------------------------------------------
C           End of the program
C------------------------------------------------------------------------------
      deallocate ( X, CO, AA, SNor,B,C, stat = MemErr )
      if( MemErr .ne. 0 )  write (*,*) ' Warning: Deallocation error!'
      stop ' '

111   format ( 10X,'Coefficients :',/,100E12.5 )
9999  write(*,'(/,3A)')' *** Error in the opening of the file !***'
      stop ' '
      end
