$LARGE
CĿ
C     Name: TREE  v.7.5                                      04/22/93 00:33am 
C                                                                             
C     Description: GMDH Algorithm "Pointing Finger"                           
C                  of optimal clustrisation sorting-out                       
C                  by balance of two trees criteria.                          
C                                                                             
C     Gregory Ivakhnenko,  (c) 1992-93.                                       
C
         include        'FGRAPH.FI'

      Program  TREE
         include        'FGRAPH.FD'
      real           X   [allocatable] (:,:), X0  [allocatable] (:,:),
     +               COR [allocatable] (:,:), COR0[allocatable] (:,:),
     +               XD  [allocatable] (:,:), XS  [allocatable] (:),
     +               XCR [allocatable] (:),   XCR1[allocatable] (:),
     +               XP  [allocatable] (:,:), YP  [allocatable] (:),
     +               Y   [allocatable] (:),   YY  [allocatable] (:),
     +               XQ  [allocatable] (:),   XM  [allocatable] (:),
     +               YN  [allocatable] (:,:), YM  [allocatable] (:,:)
      integer        IR  [allocatable] (:,:), IR2 [allocatable] (:,:),
     +               IX  [allocatable] (:)
      integer        IK  [allocatable] (:,:), IQK [allocatable] (:),
     +               IK2 [allocatable] (:,:), IQK2[allocatable] (:)
      integer        IN_Card ( 10 ), IXM(100), IXN(100), MM,NN, M,N
      real           PAR_Card( 2 )
      character*12   Name                            ! File name
      character*9    Yname, Yname2, Xname, VARname   ! Graph names
      character*10   Form,  VarForm                  ! Graph output formats
      character*20   GrName                          ! Graph name
      character*1    YE,YES,QQ
      character*3    ON_OFF( 2 )
      character*11   DI_COR( 3 )
      logical        MODE,  KlMode, KlFile           ! Logical keys
      external       MODE
      common /LDAT/  JPR                   ! Print initial data
      common /LNORM/ JPRN                  ! Print normilized data
      common /LCORR/ JCOR                  ! Print correlation array
      common /LRAST/ JRAS                  ! Print distance array
      common /LCOR/  JCOR2                 ! print temporary correlation arrays
      common /LFile/ JFile, KlFile, io
      common /LGRAF/    VarForm,VarName,GrName,Xname,Yname,Yname2,Form
      record /rccoord/  curpos             ! record for pause message on graph
      automatic                            ! put everything on stack by default
C==============================================================================
C  X   (M,N) - 室 ᨢ
C  X0  (M,N) - copy of NORMIR 室 ᨢ
C  COR (N,N) - ᨢ ﭨ ( ५権 )
C  COR0(N,N) -  ᨢ ﭨ ( ५権 )
C  XD  (M,N) - 㦥  ५樨
C  XS  (N)   - 㦥  ५樨
C  IX  (N)   -  ⢨⥫ ஢ 祪   쥤
C  XCR (N)   -  祭    ⥪饩  
C  XS1 (N)   -    
C  IR  (2,N) - ᨢ  祪 ࢮ ॢ
C  IR2 (2,N) - ᨢ  祪 ண ॢ
C  IK  (N,N) - ⠡ ஢ ࢮ ॢ
C  IK2 (N,N) - ⠡ ஢ ண ॢ
C  IQK (N)   -  ⢠ 祪  ࠬ
C  IQK2(N)   -  ⢠ 祪  ࠬ
C  IXM(100),IXN(100) -  ஢ 㦭 ⮫殢  ப   !? MM,NN -> 100
C
C      AL    - ⥪騩 樥 㬫 Lambda
C      DAL   - 蠣  樥 㬫
C      IQ    - ⢮ 蠣
C      JKL   - 䫠 롮  (distance[1],correlation[2],both[0])
C      JGRAPH-  뢮 䨪
C      KLP   -     ENTER   뢮 䨪 (1-)
C      JOS   - ⢮ ᥩ  ⮣쭮 ஥஢
C      JPR   -   室 
C      JPRN  -   ନ஢ 
C      JCOR  -    ५権 (ﭨ)
C      JCOR2 -   ஬  ५権 (ﭨ)
C     MM,NN  - ⢨⥫쭮 祭 M  N 㦭 ⮫殢  ப
C==============================================================================
      EPS = +1.E+10     ! Parameters
      NP  = 1
      YE  = 'Y'
      YES = 'y'
      ON_OFF( 1 ) = 'Off'
      ON_OFF( 2 ) = 'On '
      DI_COR( 1 ) = 'Distance   '
      DI_COR( 2 ) = 'Correlation'
      DI_COR( 3 ) = 'Not found  '
      write (*,1111)
      write (*,3333)
      write (*,2222)
      write (*,*)
C -----------------------------------------------------------------------------
C        Data for the graph
C -----------------------------------------------------------------------------
            KlMode = .true.                  ! Graphic mode flag
            KlFile = .true.                  ! File write clasterisations flag
            AL1    = 0.                      ! The best Lambda to save
            AL0    = 1.
            GrName = 'Tree Clusterisation'   ! Graphic texts
            Yname  = 'Correlat '
            Yname2 = 'Distance '
            Xname  = '     Step'
            VARname= 'Lambda ='
C ----------------------------------------------------------------------------
C        Data and parametrs input
C ----------------------------------------------------------------------------
      call CardIN (Name,Form, M,N, MM,NN,IXM,IXN, PAR_Card,2,IN_Card,10)

      allocate ( X(MM,NN),  X0(MM,NN),  COR(NN,NN), COR0(NN,NN),
     +           XD(MM,NN), XS(NN),     XCR(NN),    XCR1(NN),
     +           IR(2,NN),  IR2(2,NN),  IX(NN),
     +           IK(NN,NN), IQK(NN),    IK2(NN,NN), IQK2(NN),
     +           XP(MM,NP), YP(NP),     Y(NN),      YY(MM),
     +           XQ(MM),    XM(MM),     YN(2,NN),   YM(MM,2),
     +           stat = MEMERR )
      if(MEMERR.ne.0)  stop ' Abort: Not enough storage!'

      AL    = PAR_Card( 1 )
      DAL   = PAR_Card( 2 )
      IQ    = IN_Card ( 1 )
      JKL   = IN_Card ( 2 )
      JGRAPH= IN_Card ( 3 )
      KLP   = IN_Card ( 4 )
      JFile = IN_Card ( 5 )
      JNew  = IN_Card ( 6 )
      JPR   = IN_Card ( 7 )
      JPRN  = IN_Card ( 8 )
      JCOR  = IN_Card ( 9 )
      JCOR2 = IN_Card ( 10)
      write (*,333)  AL, DAL, IQ
      write (*,222)  DI_COR(JKL), ON_OFF(JGRAPH+1), ON_OFF(JPR+1),
     +            ON_OFF(JPRN+1), ON_OFF(JCOR+1), ON_OFF(JCOR2+1)
      write (*,*)
      if( JPR .ne. 0 )  PAUSE
      call DATPIN ( Name, Form, M,N, MM,NN, X, IXM,IXN )
      Form    = '(F6.3)'                   ! ଠ 뢮  䨪
      VarForm = '(F6.4)'
C ----------------------------------------------------------------------------
C        Normilizing of data array X
C -----------------------------------------------------------------------------
      call NORM ( M,N, MM,NN, X )          ! ନ஢  ⮫栬
      do 60 J= 1,M
         do 60 I= 1,N
60       X0(J,I) = X(J,I)
C -----------------------------------------------------------------------------
C        Tree construction :
C          - by euclid distance minimum                              JKL = 1
C                                                   1 - COR(J,I)
C          - by correlation coefficient maximum    -------------- ;  JKL = 2
C                                                       2
C ----------------------------------------------------------------------------
      if( JKL .eq. 1 ) then
         INUM   = 1                        ! Curves number
         write (*,*)
         write (*,*) '         *  Distance measure of proximity  *'
         write (*,*)
      elseif( JKL .eq. 2 ) then
         INUM   = 1
         write (*,*)
         write (*,*) '         *  Correlation measure of proximity  *'
         write (*,*)
      elseif( JKL .eq. 0 ) then
       INUM   = 2
       write (*,*)
       write (*,*)
     +   '         *  Distance & Correlation measure of proximity  *'
       write (*,*)
      endif
C------------------------------------------------------------------------------
      if( JGRAPH .ne. 0) then
         JPR  = 0                          ! Initializing of output flags on graphics
         JPRN = 0
         JCOR = 0
         JCOR2= 0
         write (*,*) '       Wait  a  bit  please ...'
         write (*,*)
      endif
      JRAS = JCOR
      JKL0 = JKL
      if( JFile .ne. 0 ) then
        io  = 2
        open ( io, file='RESULT',status='UNKNOWN',mode='WRITE',err=9999)
      else
        KlFile = .false.
      endif
C -----------------------------------------------------------------------------
C              Noise decreasing step cycle
C -----------------------------------------------------------------------------
200   do 10 KK= 1,IQ
         if( JPR .ne. 0 ) then
            write (*,111)
            write (*,*) ' Noise coefficient value  AL =',AL
            write (*,*)
         endif

         JKL = JKL0                        ! Corr to Dist if JKL = 0
C -----------------------------------------------------------------------------
C              First tree constructing
C -----------------------------------------------------------------------------
170   continue
      do 70 J= 1,M                         ! Recover X matrix from noise
         do 70 I= 1,N
70       X(J,I) = X0(J,I)
                                           ! Clustrisation
      call Cor_Tree ( JKL, M,N, MM,NN, X,XD,XS, COR,COR0, IR, IX)
C -----------------------------------------------------------------------------
C              Second noise tree constructing
C -----------------------------------------------------------------------------
                                           ! Put noise on second tree
      call ShumTree ( AL, M,N, MM,NN, X, COR0, IX )
                                           ! Clusterisation
      call Cor_Tree ( JKL, M,N, MM,NN, X,XD,XS, COR,COR0, IR2, IX)
C -----------------------------------------------------------------------------
C              Cluster tables constructing and criteria evaluation
C -----------------------------------------------------------------------------
      call Cri_Bala ( JKL, AL,DAL, AL1,NKL1,JKL1, N,NN,
     +                IK,IK2,IR,IR2, IQK,IQK2, XCR )
C --------------------------------------------------------------------------
C           Graphs
C --------------------------------------------------------------------------
      if( JKL .eq. 0)  then                      ! Changing of proximity type
            do 160 I= 1,N-1                      ! to corr
160         XCR1(I) = XCR(I)                     ! if both dist & corr
         JKL  = 2
         INUM = 2
         goto 170
      elseif( JKL .eq. 1 )  then
         Yname = Yname2                          ! To write 'Dist ' on graph
      endif

180   if( JGRAPH .ne. 0 ) then                   ! Set graphics mode
         if( KlMode ) then
            if( MODE ()) then
               stop ' Sorry, this program requires a graphics card !'
            endif
            dummy = Init_Axe()
            KlMode = .false.                     ! Set key for not to set mode
         endif                                   ! Draw graph
         if( AL1 .eq. AL ) then                  ! Draw Pause if minimum exists
             NP = 1
         else
             NP = KLP
         endif
         call GRAF ( INUM, NP, AL, 0,0,0,0, 1,N-1, 1,N-1, NN,NN,
     +               XCR, XCR1 )

      elseif( AL1 .eq. AL .or. KLP .ne. 0 ) then ! In text mode if KLP key
         PAUSE                                   ! or if minimum exists - PAUSE
      endif

      if( AL1 .eq. AL ) then                     ! If minimum exists - change AL
         if( AL + (DAL/2) .ge. AL0 ) then
            AL = AL - DAL                        ! Decrease Lambda (if minimum)
         else                                    ! if increase not possible
            if( AL0 .eq. 1.) then
               AL = AL + DAL                     ! Increase Lambda if minimum
            else                                 ! at first
               AL = AL + (DAL / 2)               ! Increase Lambda once if minimum
            endif                                ! not at first
         endif
      else
         AL0= AL
         AL = AL - DAL                           ! Decrease Lambda in general
      endif
10    if( AL .gt. 1  .or.  AL .le. 0 ) goto 20   !  0 < AL < 1 - exit from cycle
C ----------------------------------------------------------------------------
20    if( JGRAPH .ne. 0 ) then
         I = settextcolor( 12 )
         call settextposition( 4, 12, curpos )
         call outtext( 'End:  press Enter    ')
         read (*,*)
      endif
      if( .not. KlMode ) dummy = setvideomode( $DEFAULTMODE )

      if( AL1 .eq. 0 ) JKL1 = 3
      write (*,444) NKL1, AL1, DI_COR(JKL1)
      if( JFile .ne. 0 )  write (*,555)

      if( JNew .ne. 0 ) then
         write (*,'(///,10X,A\)')
     +            'Enter new noise parameters ?  (Y/N) -> '
         read  (*,'(A1)') QQ
         if( QQ .eq. YE  .or.  QQ .eq. YES )  then
            write (*,*)
210         write (*,'(10X,A\)') 'Enter initial noise value -> '
            read (*,'(F7.5)') AL
            if( AL .le. 0.01 .or. AL .gt. 1 ) goto 210
220         write (*,'(10X,A\)') 'Enter noise decrease step -> '
            read (*,'(F7.5)') DAL
            if( DAL .lt. 0.001 .or. DAL .ge. 1 ) goto 220
230         write (*,'(10X,A\)') 'Enter number of steps     -> '
            read (*,'(I3)') IQ
            if( IQ .lt. 1 ) goto 230
            write (*,*)
            write (*,*) '         Wait please...'
            KlMode = .true.                               ! Graphic mode flag
            goto 200
         endif
      endif
C --------------------------------------------------------------------------
      if( JFile .ne. 0 )  close( io )
      deallocate ( X, X0, COR, COR0, XD, XS, XCR, XCR1, IR, IR2, IX,
     +             XQ, XP, YP, Y, YY, XM, YN, YM,
     +             IK, IQK, IK2, IQK2, stat = IERR )
      if(IERR.ne.0) write (*,*) ' Warning: Deallocation error!'
      write (*,*)
      stop ' '
111   format (//,79('*'))
222   format (/10X,'Flags:  Proximity type - ',A11,/,
     +         18X,'Graphs output  - ',A3,/,
     +         18X,'Initial  data   output - ',A3,/,
     +         18X,'Normalized data output - ',A3,/,
     +         18X,'Proximity array output - ',A3,/,
     +         18X,'Temporary array output - ',A3)
333   format (/10X,'Noise coeficient =',F6.4,
     +          7X,'Noise decrease step =',F7.5,/,
     +         31X,'Number of steps =',I3)
444   format (///10X,'The best clusterisation :',/,20X,'Step   =',I3,
     +         /,20X,'Lambda noise coefficient =',F5.3,
     +         /,20X,'Type of proximity - ',A11, //)
555   format (/,20X,
     +        'Look into the file ~RESULT~ for clusterisation results.')
3333  format(10X,'',20X,'"Pointing Finger"',20X,'',/,10X,'',
     +       3X,'GMDH Algorithm of Optimal Clustrisation Sorting-out',
     +        3X,'',/,
     +       10X,'',15X,'by Balance of Trees Criteria',14X,'',/,
     +       10X,'',3X,'Version 7.5   Gregory Ivakhnenko (c)',
     +               4X,'    10.1992',3X,'')
1111  format (10X,'',
     +'ͻ')
2222  format (10X,'',
     +'ͼ')
9999  stop '*** Error: Cannot open file ! ***'
      end
