$LARGE
CĿ
C          Name: Stat  v.1.0                                 02/15/93 01:00am 
C                "Pair Probabilities" algorithm                               
C   Description: MGDH Algorithm of Multilayered Statistical Decisions Theory  
C                for solving pattern recognition learning problem.            
C                                                                             
C   Gregory Ivakhnenko (c)                                                    
C
      program  Stat
      integer  IX [allocatable] (:,:),
     +         NQ [allocatable] (:),     IP [allocatable] (:),
     +         IN [allocatable] (:),     IQ [allocatable] (:)

      real     AA [allocatable] (:,:,:), BB [allocatable] (:,:,:),
     +         SUM[allocatable] (:,:),   Q  [allocatable] (:)
      integer  In_Card (5), IXM(100), IXN(100), MM,NN, M,N, NVar
      real     Par_Card(1), PatX(6)
      character*12   Name                    ! File name (for input)
      character*10   Form                    ! Input format
      character*1    NO,NON,QQ
      common /LDAT/  JPR                     ! Print initial data flag
      automatic
C      integer  IX(4,12),   NQ(3),     IP(12)
C      real     AA(3,25,6), BB(12,6,3), SUM(12,3), Q(3)
C============================================================================
C            IXĿ  NQĿ PatXĿ
C Data array:  00        1            - first pattern
C              0         1    2     N1
C              ĴN1  Ĵ     Ĵ
C                        0            - second pattern
C                                   N2
C              ĴN2  Ĵ     Ĵ
C              01001 ... .    .     .
C              N         JN
C                         M      \
C                                 \number of points in column (pattern) vectors
C     JN  - number of patterns
C     LQ  - number of levels (discrets)
C     IPa - number of variables pairs
C     IPL - number of discrets pairs
C     IX (M,N)       - initial data array
C     AA (JN,IPL,IPa)- array of probability of discret pair appearence
C     BB (N,IPa,JN)  - array of probability characteristics of patterns recognised
C     PatX (NVar)    - patterns limiting numbers vector
C     NQ (JN)        - quantity of points in pattern vector
C     SUM(N,JN)      - probability sum vector for each point
C     Q  (JN)        - tmp sum vector
C     IQ (N)         - tmp point vector
C     IN (N)         - point index vector
C     IP (N)         - vector of recognised patterns
C
C  KlFile-   १⮢  䠩   ([1] - 뢠,[0] -   )
C  JGRAPH-  뢮 䨪              ([1] - 뢮,  [0] -  뢮)
C  JPR   -   室       ([1] - ,  [0] -   )
C  IXM(100),IXN(100)  -  ஢ 㦭 ⮫殢  ப
C  In_Card(),Par_Card() -  ⢥  楫 ࠬ஢  䠩 _CARD
C  MM,NN - ⢨⥫쭮 祭 ࠧ୮⥩ M  N 㦭 ⮫殢  ப
C================================================================================
      write (*,1111)
      write (*,9999)
      write (*,2222)
      NVar = 6                               ! Maximum number of patterns in PatX
      NO  = 'N'
      NON = 'n'
C------------------------------------------------------------------------------
C        Size  of  data  and  parameters  input
C------------------------------------------------------------------------------
      call Card_In ( NVar, Name,Form, M,N, MM,NN, IXM,IXN,
     +               Par_Card,1,      In_Card,5,  PatX )       ! Card input
      JN    = In_Card (1)                    ! Number of patterns
      LQ    = In_Card (2)                    ! Number of discrets (levels)
      KlFile= In_Card (3)                    ! Output to file flag
      JPR   = In_Card (4)                    ! Initial data print flag
      JPRI  = In_Card (5)                    ! Array print flag

      write (*,'(5X,A30,I3)') 'Number of patterns        JN =', JN
      write (*,'(5X,A30,I3)') 'Number of discrets        LQ =', LQ
      write (*,'(5X,A30,I3)') 'Output to file flag   KlFile =', KlFile
      write (*,'(5X,A30,I3)') 'Initial data print flag  JPR =', JPR
      write (*,'(5X,A30,I3)') 'Data print flag         JPRI =', JPRI
C------------------------------------------------------------------------------
C           Data allocation
C------------------------------------------------------------------------------
      IPa = ( M**2 - M ) /2.                 ! Calculate variables pairs max number
      IPL =  LQ**2                           ! Calculate patterns  pairs max number
      allocate ( IX(M,N), AA(JN,IPL,IPa), BB(N,IPa,JN),
     +           NQ(JN),  SUM(N,JN),      Q(JN), IP(N), IN(N), IQ(N),
     +           stat = MemErr )
      if( MemErr .ne. 0 )  stop ' Abort: Not enough storage!'
C------------------------------------------------------------------------------
C           Initial array input
C------------------------------------------------------------------------------
      call DatIPIn ( Name, Form, M,N, MM,NN, IX, IXM,IXN )
C --------------------------------------------------------------------------
C           Creating quantity of points in pattern vector
C --------------------------------------------------------------------------
      NQ(1) = PatX(1)
         do 20 K= 2,JN
20       NQ(K) = PatX(K) - PatX(K-1)
C --------------------------------------------------------------------------
C           Initial data output
C --------------------------------------------------------------------------
      if( JPR .ne. 0 ) then
         write (*,*) '     Limiting pattern numbers vector :'
         call VePri ( JN, N, PatX )
         write (*,*) '     Number of points per pattern vector:'
         call ViPri ( JN, N, NQ )
      endif

      if( KlFile .ne. 0 )  then
         open( 2,file='RESULT',status='UNKNOWN',mode='WRITE',err=999 )
         if( JPR .ne. 0 )  then
            write (2,*) '     Initial data array :'
            call MaiPriF( 2, M,N, M,N, IX )
            write (2,*) '     Limiting pattern numbers vector :'
            call VePriF ( 2, JN,N, PatX )
            write (2,*) '     Number of points per pattern vector:'
            call ViPriF ( 2, JN,N, NQ )
         endif
      endif

      if( JPRI .ne. 0 ) then
         write (*,4444)
         NPL = 0
         do 30 I1= 1,LQ
            do 30 I2= 1,LQ
               NPL = NPL + 1
30             write (*,5555) NPL,I1,I2      ! Write patterns pairs
      endif
      do 50 I= 1,N
50    IN( I ) = I                            ! Fill index points vector

300   do 40 K= 1,JN                          ! Entry point of procedure loop
         do 40 I= 1,IPL
            do 40 J= 1,IPa
40          AA( K,I,J ) = 0.                 ! Initialize probability array
C-----------------------------------------------------------------------------
C           Calculate array of probability of discret pair appearence
C-----------------------------------------------------------------------------
      NPa = 0
      do 60 J1= 1,M                          ! Variables pairs loop
      do 60 J2= J1+1,M
         NPa = NPa + 1                       ! Count pair number NPa
         do 60 I1= 1,LQ                      ! Discrets pairs loop
         do 60 I2= 1,LQ
            L1 = 1
            L2 = PatX(1)
            do 70 K= 1,JN                    ! Pattern loop
               L2 = PatX(K)                  ! Assign pattern limits
               do 80 I= L1,L2
                  if( IX( J1,I ) .eq. I1 .and.       ! Catch pair in table
     +                IX( J2,I ) .eq. I2 )   then

                     NPL = I1 * LQ - ( LQ - I2 )     ! Count discret pair number
                     AA( K, NPL, NPa ) = AA( K, NPL, NPa )
     +                                   + 1./NQ(K)  ! Write probability in array AA
                  endif
80             continue
70             L1 = L2 + 1
60    continue
C-----------------------------------------------------------------------------
C           Write array of probability characteristics of patterns recognised
C-----------------------------------------------------------------------------
      do 100 I= 1,N                          ! Point loop
         NPa = 0
         do 120 J1= 1,M                      ! Variables pairs loop
            do 120 J2= J1+1,M
               NPa = NPa + 1                 ! Count variable pair number NPa
               I1 = IX(J1,I)                 ! Discret pair for variable pair
               I2 = IX(J2,I)
               NPL = I1 * LQ - ( LQ - I2 )   ! Count discret pair number
                  do 120 K= 1,JN
120               BB( I, NPa, K ) = AA( K, NPL, NPa )   ! Write probability in array

         do 130 K= 1,JN
            S = 0
            do 140 J= 1,IPa
140            S = S + BB(I, J, K)           ! Calculate probabilities sum
            Q(K) = S                         ! for patterns (by current point)
130         SUM(I,K) = S

         call MaxVe ( Vmax,Nmax, JN,JN, Q )  ! Found more probable pattern
100      IP(I) = NMax
C-----------------------------------------------------------------------------
C           Results output
C-----------------------------------------------------------------------------
      if( JPRI .ne. 0 ) then
         write (*,888)
         do 90 K= 1,JN
            L = 0
            write (*,6666) K,( I, I= 1,IPL )
            NPa = 0
            do 110 J1= 1,M
               do 110 J2= J1+1,M
                  NPa = NPa + 1
110            write (*,444) NPa, J1,J2,( AA( K,I,NPa ), I= 1,IPL )
90          write (*,*)

         write (*,*)
         write (*,3333)
         do 150 I= 1,N
            L = 0
            write (*,333) I,( J, J= 1,IPa )
            do 160 K= 1,JN
160            write (*,555) K, ( BB( I,J,K ), J= 1,IPa )
150         write (*,*)

         write (*,666)
         call MatPri( N,JN, N,JN, SUM )
         if( KlFile .ne. 0 ) then
            write (2,666)
            call MatPriF( 2, N,JN, N,JN, SUM )
         endif
      endif

      write (*,777)
      call ViPriNo  ( N,N, IP )

      if( KlFile .ne. 0 ) then
         write (2,777)
         call ViPriNoF ( 2, N,N, IP )
      endif
C------------------------------------------------------------------------------
C     Found points with non-correspondent pattern number, move them to pattern and repeat procedure
C------------------------------------------------------------------------------
      KL = 0
      K = 1                                   ! Pattern number
      do 200 I= 1,N                           ! Point loop
         if( PatX( K ) .lt. I )  K = K + 1    ! Catch changing of pattern number

         if( IP(I) .ne. K ) then              ! Found non-correspondence
            if( KL .eq. 0 ) then              ! First appearence
               write (*,'(///,4X,A23,I3,A28,I2,A1)')
     +         'Its founded that point',I,
     +         ' is corresponded to pattern ',IP(I),'.'
               write (*,'(/5X,2A\)')
     +         'Can it been moved to that pattern and ',
     +         'procedure repeated ?  (N/Y) -> '              ! Dialog (Y/N)
               read  (*,'(A1)') QQ
               if( QQ .eq. NO  .or.  QQ .eq. NON ) goto 200   ! Dont move - found another point
            endif

            KL = 1
            NewP = IP(I)                      ! Target pattern number
            J1   = IN(I)                      ! Save point number
            NQ( NewP ) = NQ( NewP ) + 1       ! Increase, decrease number of
            NQ( K )    = NQ( K )    - 1       !  points in two patterns
               do 180 J= 1,M                  ! Copy point to tmp vector
180            IQ( J ) = IX( J,I )

            if( NewP .lt. K  ) then           ! Move up or down
               II = PatX( NewP ) + 1          ! Up - calculate target position
               do 190 L= I-1, II, -1
                  IP( L+1 ) = IP( L )         ! Move pattern numbers for points
                  IN( L+1 ) = IN( L )         ! Move point numbers
                  do 190 J= 1,M
190                  IX( J,L+1 ) = IX( J,L )  ! Move part of points down

               do 230 L= NewP, K-1            ! Change limits of patterns between
230               PatX( L ) = PatX ( L ) + 1  !  target and source patterns
            else
               II = PatX( NewP )              ! Down - calculate target position
               do 210 L= I+1,II
                  IP( L-1 ) = IP( L )
                  IN( L-1 ) = IN( L )
                  do 210 J= 1,M
210                  IX( J,L-1 ) = IX( J,L )  ! Move part of points up

               do 220 L=  K,NewP-1            ! Change limits of patterns
220               PatX( L ) = PatX( L ) - 1
            endif

            IP( II ) = NewP                   ! Write new pattern number to point
            IN( II ) = J1                     ! Write to index vector
            do 240 J= 1,M                     ! Write tmp vector to new point location
240            IX( J,II ) = IQ( J )
            if( NQ(K) .eq. 0 ) then           ! Last point in pattern
               do 250 J= K+1,JN
                  NQ  ( J-1 ) = NQ  ( J )
250               PatX( J-1 ) = PatX( J )
               JN = JN - 1
               do 260 J= I+1,N
260            IP( J ) = IP( J ) - 1
               if( NewP .gt. K ) IP(I) = IP(I) - 1
            endif

            write (*,'(/,5X,A9,I3,A21,I3,A12,I2,A3,/)')
     +      '*   Point',I,' is moved to position',II,
     +      ' of pattern ',NewP,'  *'
         endif
200   continue
C-----------------------------------------------------------------------------
C           Write changed arrays
C-----------------------------------------------------------------------------
      if( KL .ne. 0 ) then
         write (*,*) '     New point number sequence :'
         call ViPriNo ( N, N, IN )
         if( KlFile .ne. 0 ) then
            write (2,*) '     New point number sequence :'
            call ViPriNoF ( 2, N,N, IN )
         endif
         if( JPR .ne. 0 ) then
            write (*,*) '     Data array :'
            call MaiPri( M,N, M,N, IX )
            write (*,*) '     Limiting pattern numbers vector :'
            call VePri ( JN, N, PatX )
            write (*,*) '     Number of points per pattern vector:'
            call ViPri ( JN, N, NQ )
            write (*,*)
            if( KlFile .ne. 0 )  then
               write (2,*) '     Data array :'
               call MaiPriF( 2, M,N, M,N, IX )
               write (2,*) '     Limiting pattern numbers vector :'
               call VePriF ( 2, JN,N, PatX )
               write (2,*) '     Number of points per pattern vector:'
               call ViPriF ( 2, JN,N, NQ )
               write (2,*)
            endif
         endif
         goto 300                             ! Repeat procedure
      endif
C------------------------------------------------------------------------------
C           End of the program
C------------------------------------------------------------------------------
      if( KlFile .ne. 0 ) close (2)
      deallocate ( IX,NQ,IP,AA,BB,SUM,Q,IQ,IN ,stat = IErr )
      if( IErr .ne. 0 )  write (*,*) ' Warning: Deallocation error!'
      stop ' '
999   write(*,'(/,3A)')' *** Error in the opening of file ',Name,'!***'
      stop
111   format (I2)
333   format (I4,2X,100I5)
6666  format (I4,6X,100I5)
444   format (I4,2X,I2,I2,1X,100F5.2)
555   format (I4,3X,100F5.2)
666   format (3X,'Probabilities sum vector for points on patterns :')
777   format (//,6X,'Calculated pattern numbers for points :')
888   format (/  3X,'Probability of discret pair appearence :',
     +         /,79(''))
3333  format(/,3X,'Probability characteristics of patterns recognised:',
     +         /,79(''))
4444  format (5X, 'Discret pairs :')
5555  format (10X,'Pair no.',I4,' -   ',I3,'  &',I3)
9999  format(' ',9X,'MGDH Algorithm of Multilayered Statistical ',
     +               'Decisions Theory', 9X,'',
     +     /,' ',15X,'for solving pattern recognition learning ',
     +               'problem',14X,'',
     +     /,' ',15X,'Version 1.0',14X,'Gregory Ivakhnenko  (c)',
     +            14X,'')
1111  format (/,' ',
     +'ͻ')
2222  format   (' ',
     +'ͼ')
      end
