CĿ
C     Name: PROPOR                                           04/17/93 11:01pm 
C                                                                             
C     Description: Divide and center Y graph axe.                             
C                                                                             
C     Gregory Ivakhnenko (c), 1992.                                           
C

      subroutine PROPOR ( SY, Y1,Y2, VMax,VMin, SLow,ILow, ID,DY,D, KR)
      integer*2   Y1,Y2
      automatic
C==============================================================================
C        SLow  - Low mark value
C        ILow  - low mark position in pixels
C        ID,D  - number of pixels and function in interval
C        DY    - coefficient for calculation of function position
C        KR    - number of intervals on axe
C==============================================================================
      S = SY
      if( S .ge. 1) then
         LL = 1
         if( S .lt. 10) then
C             if(S .gt. 3) goto 40
             LL = LL - 1                           ! Fix exponent
             goto 40
         endif

      elseif( S .gt. 0)  then
         LL = 0
60          S = S * 10
            if( S .le. 1) then
               LL = LL - 1
               goto 60
            endif
            if( S .le. 3.7) LL = LL - 1            !
            goto 40
      endif
C -----------------------------------------------------------------------------
10    S = S / 10
      if( S .ge. 10) then                          !
         LL = LL + 1
         goto 10
      endif
40    I1= S
      I = S * 10
C -------------------------------------------------------------------------
      if(I .gt. 97) then                           !
         KR = 10
         goto 30
      endif
      if(I .gt. 40) then
         KR = I1
         goto 30
      endif

      L = 2
20    KR = I / L                                   !
      if( KR .ge. 10 )  then
         L = L + 1
         goto 20
      endif
C -----------------------------------------------------------------------------
C           Degree definition
C -----------------------------------------------------------------------------
30    if( LL .le. 1)  then                         ! Degree value
         SL1 = 1
            do 50 I= 1, LL+1,-1
50          SL1 = SL1 / 10
      else
         SL1 = 10 ** (LL - 1)                      !
      endif
C -----------------------------------------------------------------------------
C           Definition of number of pixels in interval
C -----------------------------------------------------------------------------
80    IHigh = VMax / SL1 + 1                  ! High mark (no exponent)
      Low   = VMin / SL1                      ! Low  mark
      if( IHigh-Low .lt. KR )  KR = IHigh - Low

      L = (IHigh - Low) / KR                  ! Number of sticks in interval
      D = L * SL1                             ! Interval of function between marks

      DY = (Y1 + Y2 - 10) / SY                ! Y coordinate coeficient
      ID = (DY * D) - 0.6                     ! Number of pixels in interval

      if( Low .le. 0  .and.  IHigh .ge. 0 ) then    ! Zero grid line
         I  = -Low / L                        ! Number of intervals below zero
         I0 = (( -VMin ) * DY) - Y2           ! Zero pixels
70       J = I * ID                           ! Number of pixel under
         ILow = I0 - J                        ! New low mark position
         if( ILow .gt. -Y2 ) then
            if( I .eq. 0 ) then
               SLow = Low * SL1 + D           ! No intervals under zero
               ILow = ((SLow - VMin ) * DY) - Y2
               return
            else
               I = I - 1                      ! Decrease intervals number
               goto 70
            endif
         endif
         KR = KR + 1                          ! One more grid line
         Low = -L * I                         ! New low mark
         SLow = Low  * SL1                    ! Low mark value
      else                                          ! No zero
         SLow = Low  * SL1                    ! Low mark value
         if( SLow .gt. VMin ) then
            KR = KR + 1                       ! One more grid line
         else
            SLow = SLow + D
         endif
         ILow = ((SLow - VMin ) * DY) - Y2    ! Low stick pixel position
      endif
      return
      end
